package at.jku.ssw.worms.score.servlet;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import at.jku.ssw.worms.score.ScoreConstants;
import at.jku.ssw.worms.score.ScoreUtil;
import at.jku.ssw.worms.score.crypto.Cryptor;

public class ScoreServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;

	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		handleRequest(req, resp);
	}

	@Override
	protected void doPost(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		handleRequest(req, resp);
	}

	private void handleRequest(HttpServletRequest req, HttpServletResponse resp)
			throws IOException, ServletException {
		storeScore(req);
		gotoHighscoreView(req, resp);
	}

	private void storeScore(HttpServletRequest req) {
		String paramStr = req.getParameter(ScoreConstants.SCORE);
		if (paramStr != null) {
			String decryptedStr = Cryptor.decrypt(paramStr);
			String[] params = decryptedStr.split(":", 3);
			try {
				// protocol: "<score>:<salt>:<player>"
				int score = Integer.parseInt(params[0]);
				String player = params[2].trim();
				if (player.isEmpty()) {
					player = "Anonymous";
				}
				ScoreUtil.putScoreIntoDatabase(player, score);
			} catch (Exception ign) {
				Logger.getLogger(ScoreServlet.class.getName()).log(
						Level.SEVERE, ign.getMessage(), ign);
			}
		}
	}
	
	private void gotoHighscoreView(HttpServletRequest req,
			HttpServletResponse resp) throws ServletException, IOException {
		String target = resp.encodeURL("/view.do");
		RequestDispatcher rd = getServletContext().getRequestDispatcher(target);
		rd.forward(req, resp);
	}

}
